#ifndef _MODBUS_MSXE301X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE301X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Wed Aug 19 17:14:03 2015*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE301X__ANALOGINPUTGETAUTOREFRESHVALUES=100,
MSXE301X__ANALOGINPUTGETAUTOREFRESHVALUESEX=1000,
MSXE301X__ANALOGINPUTGETCHANNELTYPE=101,
MSXE301X__ANALOGINPUTGETCHANNELTYPEEX=1050,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE301x__AnalogInputGetAutoRefreshValues_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	uint32_t ulValue[16];
 } __PACKED;

struct MSXE301x__AnalogInputGetAutoRefreshValuesEx_parameters_t
{
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
	uint32_t ulCounterValue;
	uint32_t ulValue[16];
 } __PACKED;

struct MSXE301x__AnalogInputGetChannelType_parameters_t
{
	uint32_t ulOption01;
	uint32_t ulType[16];
 } __PACKED;

struct MSXE301x__AnalogInputGetChannelTypeEx_parameters_t
{
	uint32_t ulOption01;
	uint32_t ulType[16];
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Returns the values acquired in auto refresh mode.</p>
*<p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR> Dummy </VAR></b> parameter</p>

* <p> @param[out]
*             <b> <VAR>iReturnValue :</VAR> </b>
*                                     <ul>
*									  <li>    0: means the remote function performed OK \n
*                                     <li>   -1: means an system error occured \n
*                                     <li> -100: GetAutoRefreshAllValues kernel function error\n
*									  </ul>
*</p>
*<p> @param[out] <b> <VAR>ulTimeStampLow : </VAR> </b> number of microseconds since the begin of the second </p>
*
* <p> @param[out] <b> <VAR>ulTimeStampHigh : </VAR> </b> number of seconds since the Epoch </p>
*
* <p> @param[out] <b> <VAR>ulCounterValue : </VAR> </b> Array that contain the counter values </p>
*
* <p> @param[out] <b> <VAR>ulValue : </VAR> </b> Array that contain the channels values
*											<ul>
*                                            <li> ulValues [0] : Channel 0 value \n
*                                            <li> ... \n
*                                            <li> ulValues [15] : Channel 15 value \n
*											</ul></p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE301x__AnalogInputGetAutoRefreshValues(struct modbus * modbus,struct MSXE301x__AnalogInputGetAutoRefreshValues_parameters_t * Response);



/** <p>Returns the values acquired in auto refresh mode.</p>
*<p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR> Dummy </VAR></b> parameter</p>

* <p> @param[out]
*             <b> <VAR>iReturnValue :</VAR> </b>
*                                     <ul>
*									  <li>    0: means the remote function performed OK \n
*                                     <li>   -1: means an system error occured \n
*                                     <li> -100: GetAutoRefreshAllValues kernel function error\n
*									  </ul>
*</p>
*<p> @param[out] <b> <VAR>ulTimeStampLow : </VAR> </b> number of microseconds since the begin of the second </p>
*
* <p> @param[out] <b> <VAR>ulTimeStampHigh : </VAR> </b> number of seconds since the Epoch </p>
*
* <p> @param[out] <b> <VAR>ulCounterValue : </VAR> </b> Array that contain the counter values </p>
*
* <p> @param[out] <b> <VAR>ulValue : </VAR> </b> Array that contain the channels values
*											<ul>
*                                            <li> ulValues [0] : Channel 0 value \n
*                                            <li> ... \n
*                                            <li> ulValues [15] : Channel 15 value \n
*											</ul></p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE301x__AnalogInputGetAutoRefreshValuesEx(struct modbus * modbus,struct MSXE301x__AnalogInputGetAutoRefreshValuesEx_parameters_t * Response);



/** <p>Return the type of the analog input channels</p>
*<p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved</p>

* <p> @param[out]
*             <b> <VAR>iReturnValue :</VAR> </b>
*                                     <ul>
*									  <li>    0: means the remote function performed OK \n
*                                     <li>   -1: means an system error occured \n
*									  </ul>
*</p>
* <p> @param[out] <b> <VAR>ulType : </VAR> </b> Array that contain the channels type (0 : voltage, 1 : current)
*											<ul>
*                                            <li> ulType [0] : Channel 0 type \n
*                                            <li> ... \n
*                                            <li> ulType [15] : Channel 15 type \n
*											</ul></p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE301x__AnalogInputGetChannelType(struct modbus * modbus,struct MSXE301x__AnalogInputGetChannelType_parameters_t * Response);



/** <p>Return the type of the analog input channels</p>
*<p><b>Parameters:</b></p><ul>
* <p>@param[in] <b><VAR> ulOption1 </VAR></b> Reserved</p>

* <p> @param[out]
*             <b> <VAR>iReturnValue :</VAR> </b>
*                                     <ul>
*									  <li>    0: means the remote function performed OK \n
*                                     <li>   -1: means an system error occured \n
*									  </ul>
*</p>
* <p> @param[out] <b> <VAR>ulType : </VAR> </b> Array that contain the channels type (0 : voltage, 1 : current)
*											<ul>
*                                            <li> ulType [0] : Channel 0 type \n
*                                            <li> ... \n
*                                            <li> ulType [15] : Channel 15 type \n
*											</ul></p>
* </p>
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
* <li><b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a autorefresh acquisition was not started.
* </ul></ul>
*/
			


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE301x__AnalogInputGetChannelTypeEx(struct modbus * modbus,struct MSXE301x__AnalogInputGetChannelTypeEx_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE301X__ANALOGINPUTINITANDSTARTAUTOREFRESH=1,
MSXE301X__ANALOGINPUTINITANDSTARTAUTOREFRESHEX=1100,
MSXE301X__ANALOGINPUTSTOPANDRELEASEAUTOREFRESH=2,
MSXE301X__ANALOGINPUTSTOPANDRELEASEAUTOREFRESHEX=1150,
MSXE301X__ANALOGINPUTINITANDSTARTSEQUENCE=3,
MSXE301X__ANALOGINPUTINITANDSTARTSEQUENCEEX=1200,
MSXE301X__ANALOGINPUTSTOPANDRELEASESEQUENCE=4,
MSXE301X__ANALOGINPUTSTOPANDRELEASESEQUENCEEX=1250,
MSXE301X__ANALOGINPUTINITANDSTARTSEQUENCETRIMED=5,
MSXE301X__ANALOGINPUTINITANDSTARTSEQUENCETRIMEDEX=1254,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE301x__AnalogInputInitAndStartAutoRefresh_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulAverageMode;
	uint32_t ulAverageValue;
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE301x__AnalogInputInitAndStartAutoRefreshEx_parameters_t
{
	uint32_t ulChannelMask;
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulAverageMode;
	uint32_t ulAverageValue;
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;
 } __PACKED;

struct MSXE301x__AnalogInputStopAndReleaseAutoRefresh_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MSXE301x__AnalogInputInitAndStartSequence_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t pulChannelList[16];
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulDelayMode;
	uint32_t ulDelayTimeUnit;
	uint32_t ulDelayValue;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE301x__AnalogInputInitAndStartSequenceEx_parameters_t
{
	uint32_t ulNbrOfChannel;
	uint32_t pulChannelList[16];
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulDelayMode;
	uint32_t ulDelayTimeUnit;
	uint32_t ulDelayValue;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE301x__AnalogInputStopAndReleaseSequence_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MSXE301x__AnalogInputStopAndReleaseSequenceEx_parameters_t
{
	uint32_t Dummy;
 } __PACKED;

struct MSXE301x__AnalogInputInitAndStartSequenceTrimed_parameters_t
{
	uint8_t ulNbrOfChannel;
	uint8_t pulChannelList[16];
	uint8_t pulGainArray[16];
	uint8_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint8_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint16_t ulDelayMode;
	uint8_t ulDelayTimeUnit;
	uint16_t ulDelayValue;
	uint8_t ulTriggerMask;
	uint8_t ulTriggerMode;
	uint8_t ulHardwareTriggerEdge;
	uint16_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
 } __PACKED;

struct MSXE301x__AnalogInputInitAndStartSequenceTrimedEx_parameters_t
{
	uint8_t ulNbrOfChannel;
	uint8_t pulChannelList[16];
	uint8_t pulGainArray[16];
	uint8_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint8_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint16_t ulDelayMode;
	uint8_t ulDelayTimeUnit;
	uint16_t ulDelayValue;
	uint8_t ulTriggerMask;
	uint8_t ulTriggerMode;
	uint8_t ulHardwareTriggerEdge;
	uint16_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/* <p>Starts an autorefresh acquisition using provided configuration.</p>
* <p>In the auto refresh mode the measurement value is updated automatically after each acquisition.
* The analog acquisition is initialised and the values of each channels are stored
* in memory on the Ethernet E/A module MSX-E301x.</p>
* <p>
* The client reads the data asynchronously to the acquisition via the data socket or a SOAP/MODBUS function.\n
* You can define a mask of all channels that should be acquired.</p><p>
* In the auto refresh mode you can activate the channel average value computation on
* the module:
* <ul>
*  <li> Average value calculation per channel : Each channel is acquired x times to compute an
*  average value for the channel.
*  <li> Average value calculation per sequence : All sequences are acquired x times to compute a
*  average value per channel.\n
* </ul>
* </p>
* <p>
* You can start the acquisition by a hardware trigger or a synchro trigger.\n
* </p>
* <p>
* The hardware trigger can react to a rising wave, falling wave or both edges.\n
* </p>
* <p>
* You have the following possibility:
* <ul>
*    <li> Define a number of edges before a trigger action is generated \n
* </ul>
* </p>
* <p>
* There are two trigger modes:(for the hardware or synchro trigger)
*<ul>
*    <li> One shot \n
*    <li> Sequence \n
* </ul>
* <p>
* <dl>
* <dt> One shot: </dt>
* <dd>
*    After the software start, the module is waiting for a trigger signal to start the \n
*    acquisition. After this the trigger signal is ignored.\n
* </dd>
*
* <dt> Sequence: </dt>
* <dd>
*    After the software start the module is waiting for the trigger signal and acquires x \n
*    sequences (also adjustable) and then wait again.
* </dd>
* </dl>
* </p>
* <p><b>Parameters:</b></p>
* <ul>
*
* <p>@param[in] <b><VAR>ulChannelMask :</VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel)</p>
*
* <p>
* @param[in] <b><VAR>pulGainArray :</VAR></b> Define the gain (1 or 2) to use for each channel.\n
* <ul>
* 						  <li> 1 : +10 V when Unipolar, +/-10V when Bipolar
* 						  <li> 2 : +5 V when Unipolar,  +/-5V when Bipolar
* </ul>
*                         Each index of the array correspond to the channel :\n
* <ul>
* 						  sample : \n
*                         <li> [0] : Define the gain for the channel 0  \n
* 						  <li> [1] : Define the gain for the channel 1 \n
*                         <li>... \n
* </ul>
* </p>
* @param[in] <b><VAR>pulPolarityArray :</VAR></b> Define the polarity (0:Unipolar or 1:Bipolar) to use for each channel
*                         Each index of the array correspond to the channel:
* 						  sample :
* <ul>
*                         <li> [0] : Define the polarity for the channel 0 \n
* 						  <li> [1] : Define the polarity for the channel 1 \n
*                         <li>... \n
* </ul>
* </p>
* <p>
*
* @param[in] <b><VAR>ulAverageMode :</VAR></b> Set the average mode : \n
* <ul>
*							<li> 0 : not used \n
*							<li> 1 : average per Sequence \n
*							<li> 2 : average per channel \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulAverageValue :</VAR></b> Set the average value (only used, when average is used) : \n
* <ul>
*							<li> 0 : not used \n
*							<li> max value : 255 \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulConversionTimeUnit :</VAR></b> Conversion Time Unit \n
* <ul>
*                             <li> 0 : microsecond \n
*                             <li> 1 : millisecond \n
*                             <li> 2 : second \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulConversionTime :</VAR></b> Conversion Time\n
* <ul>
* 							  <li> range from min 10 to 65535 when the unit is the microsecond
* 							  <li> range from min 1 to 65535 when the unit is the millisecond
* 							  <li> range from min 1 to 65535 when the unit is the second
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulTriggerMask :</VAR></b>	Define the source of the trigger \n
* <ul>
*                           <li> 0 : trigger disabled \n
* 							<li> 1 : Enable Hardware Digital Input Trigger \n
*                           <li> 2 : Enable Synchro Trigger \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulTriggerMode :</VAR></b>	Define the trigger mode \n
* <ul>
* 							<li> 1 : One shot trigger \n
*                           <li> 2 : Sequence trigger \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulHardwareTriggerEdge :</VAR></b>	Define the edge of the hardware trigger who generates a trigger action \n
* <ul>
*                  			<li> 1 : rising edge (Only if hardware trigger selected) \n
*                  			<li> 2 : falling edge (Only if hardware trigger selected) \n
*                  			<li> 3 : Both front (Only if hardware trigger selected) \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulHardwareTriggerCount :</VAR></b> Define the number of trigger events before the action occur
* <ul>
							<li> 0 or 1 : all trigger event start the action \n
							<li> max value : 65535 \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulByTriggerNbrOfSeqToAcquire :</VAR></b> Define the number of sequences to acquire by each trigger event \n
* <ul>
* 					<li> 0 : continuous mode \n
*                   <li> <> 0 : number of sequence : (1..0xFFFFFFFF)
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulDataFormat :</VAR></b>
* <ul>
*                        <li>D0 : Time stamp information \n
* <ul>
*                        <li> 0: no time stamp information \n
*                        <li> 1: time stamp information \n
* </ul>
*                        <li> : Data format \n
* <ul>
*                        <li> 0: Digital value \n
*                        <li> 1: Analog value (in V)  \n
* </ul>
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulOption1 :</VAR></b> Reserved
* </p>
* <p>
* @param[in] <b><VAR>ulOption2 :</VAR></b> Reserved
* </p>
* <p>
* @param[in] <b><VAR>ulOption3 :</VAR></b> Reserved
* </ul>
* </p>
* <p>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*             <b> <VAR>ReturnValue :</VAR> </b>
*							<ul>
*                            <li>  0 :  means the remote function performed OK \n
*                            <li> -1:  means an system error occured \n
*                            <li> -2: The channel mask cannot be null \n
*                            <li> -3: Channel Mask error \n
*                            <li> -4: Gain selection error \n
*                            <li> -5: Polarity selection error \n
*                            <li> -6: not available average mode \n
*                            <li> -7: not available average value \n
*                            <li> -8: The minimal converting time is 10 us !\n
*                            <li> -9: Not available conversion time unit \n
*                            <li> -10: Trigger mode : 2 different mode cannot be simultaneously be activated \n
*                            <li> -11: Hardware trigger : front definition error \n
*                            <li> -12: Hardware trigger count value not available \n
*                            <li> -13: Nbr of sequence to acquire by trigger mode not available \n
*                            <li> -14: Data format not available \n
*                            <li> -100: Channel initialisation kernel function error \n
*                            <li> -101: Conversion time initialisation kernel function error \n
*                            <li> -102: Average mode initialisation kernel function error \n
*                            <li> -103: hardware trigger initialisation/enable kernel function error \n
*                            <li> -104: hardware trigger disable kernel function error \n
*                            <li> -105: synchro trigger initialisation/enable kernel function error \n
*                            <li> -106: synchro trigger disable kernel function error \n
*                            <li> -107  Sequence trigger count initialisation error \n
*                            <li> -108: Start auto refresh kernel function error \n
*							</ul>
*
*             <b> <VAR>Syserrno :</VAR> </b> system-error code (the value of the libc "errno" code)
* </ul>
* </p>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartAutoRefresh(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelMask;
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulAverageMode;
	uint32_t ulAverageValue;
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartAutoRefresh(modbus,ulChannelMask,pulGainArray,pulPolarityArray,ulAverageMode,ulAverageValue,ulConversionTime,ulConversionTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartAutoRefresh");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartAutoRefresh\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartAutoRefresh()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartAutoRefresh OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartAutoRefresh(struct modbus * modbus,
	uint32_t ulChannelMask,
	uint32_t pulGainArray[16],
	uint32_t pulPolarityArray[16],
	uint32_t ulAverageMode,
	uint32_t ulAverageValue,
	uint32_t ulConversionTime,
	uint32_t ulConversionTimeUnit,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);


/* <p>Starts an autorefresh acquisition using provided configuration.</p>
* <p>In the auto refresh mode the measurement value is updated automatically after each acquisition.
* The analog acquisition is initialised and the values of each channels are stored
* in memory on the Ethernet E/A module MSX-E301x.</p>
* <p>
* The client reads the data asynchronously to the acquisition via the data socket or a SOAP/MODBUS function.\n
* You can define a mask of all channels that should be acquired.</p><p>
* In the auto refresh mode you can activate the channel average value computation on
* the module:
* <ul>
*  <li> Average value calculation per channel : Each channel is acquired x times to compute an
*  average value for the channel.
*  <li> Average value calculation per sequence : All sequences are acquired x times to compute a
*  average value per channel.\n
* </ul>
* </p>
* <p>
* You can start the acquisition by a hardware trigger or a synchro trigger.\n
* </p>
* <p>
* The hardware trigger can react to a rising wave, falling wave or both edges.\n
* </p>
* <p>
* You have the following possibility:
* <ul>
*    <li> Define a number of edges before a trigger action is generated \n
* </ul>
* </p>
* <p>
* There are two trigger modes:(for the hardware or synchro trigger)
*<ul>
*    <li> One shot \n
*    <li> Sequence \n
* </ul>
* <p>
* <dl>
* <dt> One shot: </dt>
* <dd>
*    After the software start, the module is waiting for a trigger signal to start the \n
*    acquisition. After this the trigger signal is ignored.\n
* </dd>
*
* <dt> Sequence: </dt>
* <dd>
*    After the software start the module is waiting for the trigger signal and acquires x \n
*    sequences (also adjustable) and then wait again.
* </dd>
* </dl>
* </p>
* <p><b>Parameters:</b></p>
* <ul>
*
* <p>@param[in] <b><VAR>ulChannelMask :</VAR></b> Mask of the channel to acquire by the auto refresh (1 bit = 1 Channel)</p>
*
* <p>
* @param[in] <b><VAR>pulGainArray :</VAR></b> Define the gain (1 or 2) to use for each channel.\n
* <ul>
* 						  <li> 1 : +10 V when Unipolar, +/-10V when Bipolar
* 						  <li> 2 : +5 V when Unipolar,  +/-5V when Bipolar
* </ul>
*                         Each index of the array correspond to the channel :\n
* <ul>
* 						  sample : \n
*                         <li> [0] : Define the gain for the channel 0  \n
* 						  <li> [1] : Define the gain for the channel 1 \n
*                         <li>... \n
* </ul>
* </p>
* @param[in] <b><VAR>pulPolarityArray :</VAR></b> Define the polarity (0:Unipolar or 1:Bipolar) to use for each channel
*                         Each index of the array correspond to the channel:
* 						  sample :
* <ul>
*                         <li> [0] : Define the polarity for the channel 0 \n
* 						  <li> [1] : Define the polarity for the channel 1 \n
*                         <li>... \n
* </ul>
* </p>
* <p>
*
* @param[in] <b><VAR>ulAverageMode :</VAR></b> Set the average mode : \n
* <ul>
*							<li> 0 : not used \n
*							<li> 1 : average per Sequence \n
*							<li> 2 : average per channel \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulAverageValue :</VAR></b> Set the average value (only used, when average is used) : \n
* <ul>
*							<li> 0 : not used \n
*							<li> max value : 255 \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulConversionTimeUnit :</VAR></b> Conversion Time Unit \n
* <ul>
*                             <li> 0 : microsecond \n
*                             <li> 1 : millisecond \n
*                             <li> 2 : second \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulConversionTime :</VAR></b> Conversion Time\n
* <ul>
* 							  <li> range from min 10 to 65535 when the unit is the microsecond
* 							  <li> range from min 1 to 65535 when the unit is the millisecond
* 							  <li> range from min 1 to 65535 when the unit is the second
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulTriggerMask :</VAR></b>	Define the source of the trigger \n
* <ul>
*                           <li> 0 : trigger disabled \n
* 							<li> 1 : Enable Hardware Digital Input Trigger \n
*                           <li> 2 : Enable Synchro Trigger \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulTriggerMode :</VAR></b>	Define the trigger mode \n
* <ul>
* 							<li> 1 : One shot trigger \n
*                           <li> 2 : Sequence trigger \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulHardwareTriggerEdge :</VAR></b>	Define the edge of the hardware trigger who generates a trigger action \n
* <ul>
*                  			<li> 1 : rising edge (Only if hardware trigger selected) \n
*                  			<li> 2 : falling edge (Only if hardware trigger selected) \n
*                  			<li> 3 : Both front (Only if hardware trigger selected) \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulHardwareTriggerCount :</VAR></b> Define the number of trigger events before the action occur
* <ul>
							<li> 0 or 1 : all trigger event start the action \n
							<li> max value : 65535 \n
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulByTriggerNbrOfSeqToAcquire :</VAR></b> Define the number of sequences to acquire by each trigger event \n
* <ul>
* 					<li> 0 : continuous mode \n
*                   <li> <> 0 : number of sequence : (1..0xFFFFFFFF)
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulDataFormat :</VAR></b>
* <ul>
*                        <li>D0 : Time stamp information \n
* <ul>
*                        <li> 0: no time stamp information \n
*                        <li> 1: time stamp information \n
* </ul>
*                        <li> : Data format \n
* <ul>
*                        <li> 0: Digital value \n
*                        <li> 1: Analog value (in V)  \n
* </ul>
* </ul>
* </p>
* <p>
* @param[in] <b><VAR>ulOption1 :</VAR></b> Reserved
* </p>
* <p>
* @param[in] <b><VAR>ulOption2 :</VAR></b> Reserved
* </p>
* <p>
* @param[in] <b><VAR>ulOption3 :</VAR></b> Reserved
* </ul>
* </p>
* <p>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*             <b> <VAR>ReturnValue :</VAR> </b>
*							<ul>
*                            <li>  0 :  means the remote function performed OK \n
*                            <li> -1:  means an system error occured \n
*                            <li> -2: The channel mask cannot be null \n
*                            <li> -3: Channel Mask error \n
*                            <li> -4: Gain selection error \n
*                            <li> -5: Polarity selection error \n
*                            <li> -6: not available average mode \n
*                            <li> -7: not available average value \n
*                            <li> -8: The minimal converting time is 10 us !\n
*                            <li> -9: Not available conversion time unit \n
*                            <li> -10: Trigger mode : 2 different mode cannot be simultaneously be activated \n
*                            <li> -11: Hardware trigger : front definition error \n
*                            <li> -12: Hardware trigger count value not available \n
*                            <li> -13: Nbr of sequence to acquire by trigger mode not available \n
*                            <li> -14: Data format not available \n
*                            <li> -100: Channel initialisation kernel function error \n
*                            <li> -101: Conversion time initialisation kernel function error \n
*                            <li> -102: Average mode initialisation kernel function error \n
*                            <li> -103: hardware trigger initialisation/enable kernel function error \n
*                            <li> -104: hardware trigger disable kernel function error \n
*                            <li> -105: synchro trigger initialisation/enable kernel function error \n
*                            <li> -106: synchro trigger disable kernel function error \n
*                            <li> -107  Sequence trigger count initialisation error \n
*                            <li> -108: Start auto refresh kernel function error \n
*							</ul>
*
*             <b> <VAR>Syserrno :</VAR> </b> system-error code (the value of the libc "errno" code)
* </ul>
* </p>
*/
		
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartAutoRefreshEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulChannelMask;
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulAverageMode;
	uint32_t ulAverageValue;
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;
	uint32_t ulOption2;
	uint32_t ulOption3;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartAutoRefreshEx(modbus,ulChannelMask,pulGainArray,pulPolarityArray,ulAverageMode,ulAverageValue,ulConversionTime,ulConversionTimeUnit,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,ulOption2,ulOption3,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartAutoRefreshEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartAutoRefreshEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartAutoRefreshEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartAutoRefreshEx OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartAutoRefreshEx(struct modbus * modbus,
	uint32_t ulChannelMask,
	uint32_t pulGainArray[16],
	uint32_t pulPolarityArray[16],
	uint32_t ulAverageMode,
	uint32_t ulAverageValue,
	uint32_t ulConversionTime,
	uint32_t ulConversionTimeUnit,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1,
	uint32_t ulOption2,
	uint32_t ulOption3
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stops the current autorefresh acquisition.</p>
* <p>
* Must be called before any another call to MSXE301x__AnalogInputInitAndStartAutoRefresh.
* </p>
* <p><b>Parameters:</b></p>
* <ul>
* <li>@param[in] <b><VAR>Dummy</VAR></b> : Reserved
* </ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li> 0 :  means the remote function performed OK
*                             <li> -1:  means an system error occured. EPERM means a autorefresh acquisition was not started
* </ul>
* </ul>
*
*
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputStopAndReleaseAutoRefresh(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputStopAndReleaseAutoRefresh(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputStopAndReleaseAutoRefresh");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputStopAndReleaseAutoRefresh\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputStopAndReleaseAutoRefresh()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputStopAndReleaseAutoRefresh OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputStopAndReleaseAutoRefresh(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stops the current autorefresh acquisition.</p>
* <p>
* Must be called before any another call to MSXE301x__AnalogInputInitAndStartAutoRefresh.
* </p>
* <p><b>Parameters:</b></p>
* <ul>
* <li>@param[in] <b><VAR>Dummy</VAR></b> : Reserved
* </ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li> 0 :  means the remote function performed OK
*                             <li> -1:  means an system error occured. EPERM means a autorefresh acquisition was not started
* </ul>
* </ul>
*
*
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputStopAndReleaseAutoRefreshEx(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/* <p> Initialise and start the analog input sequence acquisition mode </p>
* <p>
* This function is not available for the S7. See function MSXE301x__AnalogInputInitAndStartSequenceTrimed.
* </p>
* <p>
* A sequence is a list of channels (max 16) that are acquired.
* It can be any order of the channels in this list.
* </p>
* <p>
* There are different sequence modes
* <ul>
*    <li> Limited number of sequences / Continuous
*    <li> With/Without delay
* </ul>
* </p>
* <dl>
* <dt> Limited number of sequences</dt>
* <dd>After the acquisition of the defined number of sequences, the acquisition is stopped automatically.</dd>
* <dt>Continuous:</dt>
* <dd>The sequences are acquired continuously until a software-stop-command occurs.</dd>
*
* <dt>Without delay</dt>
* <dd>There is no waiting time between the acquisitions of 2 sequences.</dd>
*
* <dt>With delay</dt>
* <dd>A delay between 2 sequences can be configured: \n
* For this there are 2 delay types:
* <ul>
* <li> Mode 1: The delay time defines the time between 2 sequence beginnings. \n
* <li> Mode 2: The delay time defines the time between the end of a sequence until the beginning of the next sequence.
* </ul>
* </dd>
* </dl>
* <p>
* You can start the acquisition by a hardware or synchro trigger.
* </p>
* The hardware trigger can react to a rising, falling or both edges.\n

* <p>
* You have the following possibility:
* <ul>
*    <li> Define a number of edges before a trigger action is generated \n
* </ul>
* </p>
* <p>
* There are two trigger modes:(for the hardware or synchro trigger)
*<ul>
*    <li> One shot \n
*    <li> Sequence \n
* </ul>
* <p>
* <dl>
* <dt> One shot: </dt>
* <dd>
*    After the software start, the module is waiting for a trigger signal to start the \n
*    acquisition. After this the trigger signal is ignored.\n
* </dd>
*
* <dt> Sequence: </dt>
* <dd>
*    After the software start the module is waiting for the trigger signal and acquires x \n
*    sequences (also adjustable) and then wait again.
* </dd>
* </p>
*/

/** Initialise and start the analog input sequence acquisition mode
*
* <p><b>Parameters:</b></p>
* <ul>
*
*<p>
* @param[in] <b><VAR>ulNbrOfChannel :</VAR></b> nbr of channel in the sequence
*</p>
*<p>
* @param[in] <b><VAR>pulChannelList :</VAR></b> list of the channel who compose the sequence
*</p>
*<p>
* @param[in] <b><VAR>pulGainArray :</VAR></b> Define the gain (1 or 2) to use for each channel.\n
*							<ul>
* 						  <li> 1 : +10 V when Unipolar, +/-10V when Bipolar
* 						  <li> 2 : +5 V when Unipolar,  +/-5V when Bipolar
*                         Each index of the array correspond to the channel :\n
* 						  sample : \n
*                         <li> [0] : Define the gain for the channel 0  \n
* 						  <li> [1] : Define the gain for the channel 1 \n
*                         <li>... \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>pulPolarityArray :</VAR></b> Define the polarity (0:Unipolar or 1:Bipolar) to use for each channel \n
*                         Each index of the array correspond to the channel :\n
* 						  sample : \n
*							<ul>
*                         <li> [0] : Define the polarity for the channel 0 \n
* 						  <li> [1] : Define the polarity for the channel 1 \n
*                         <li>... \n
*							</ul>
*</p>
*
*<p>
* @param[in] <b><VAR>ulConversionTime :</VAR></b> Conversion Time (min 10 us or 40 us)
*</p>
*<p>
* @param[in] <b><VAR>ulConversionTimeUnit :</VAR></b> Conversion Time Unit \n
*							<ul>
*                             <li> 0 : us \n
*                             <li> 1 : ms \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulNbrOfSequence :</VAR></b> Number of sequence to acquire :\n
*							<ul>
*                               <li> 0 : continuous mode \n
*                               <li> <> 0 : number of sequence
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulNbrMaxSequenceToTransfer :</VAR></b> Max nbr of sequence to acquire before a data transfer : (1,65535)
*</p>
*<p>
* @param[in] <b><VAR>ulDelayMode :</VAR></b> Delay Mode : \n
*							<ul>
*                            <li> 0 : delay not used \n
*                            <li> 1 : mode 1 \n
*                            <li> 2 : mode 2
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDelayTimeUnit :</VAR></b> Selection of the time unit \n
*							<ul>
*                               0: us   \n
*                               1: ms   \n
*                               2: s
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDelayValue :</VAR></b> Delay Value : (1..0xFFFF)
*</p>
*<p>
* @param[in] <b><VAR>ulTriggerMask :</VAR></b>	Define the source of the trigger \n
*							<ul>
*                           <li> 0 : trigger disabled \n
* 							<li> 1 : Enable Hardware Digital Input Trigger \n
*                           <li> 2 : Enable Synchro Trigger \n
* 							<li> 3 : Enable both Hardware and Synchro Trigger \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulTriggerMode :</VAR></b>	Define the trigger mode \n
*							<ul>
* 							<li> 1 : One shot trigger \n
*                           <li> 2 : Sequence trigger \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulHardwareTriggerEdge :</VAR></b>	Define the edge of the hardware trigger who generate a trigger action \n
*							<ul>
*                  <li> 1 : rising front (Only if hardware trigger selected) \n
*                  <li> 2 : falling front (Only if hardware trigger selected) \n
*                  <li> 3 : Both front (Only if hardware trigger selected) \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulHardwareTriggerCount :</VAR></b> Define the number of trigger events before the action occur
*							<ul>
*							<li> 0 or 1 : all trigger event start the action \n
*							<li> max value : 65535 \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulByTriggerNbrOfSeqToAcquire :</VAR></b> define the number of sequences to acquire by each trigger event
*							<ul>
* 					<li> 0 : continuous mode \n
*                   <li> <> 0 : number of sequence : (1..0xFFFFFFFF)
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDataFormat :</VAR></b> Data format option \n
*							<ul>
*							<li>
*							<ul>
*                        D0 : Time stamp information \n
*                        <li> 0 : no time stamp information \n
*                        <li> 1 : time stamp information \n
*							</ul>
*							<li>
*							<ul>
*                        D1 : Sequence counter information \n
*                        <li> 0 : No sequence counter information \n
*                        <li> 1 : Sequence counter information \n
*							</ul>
*							<li>
*							<ul>
*                        D2 : Data format \n
*                        <li> 0 : 32/16 bit digital value \n
*                        <li> 1 : 32-bit analog value (in V) \n
*							</ul>
*							<li>
*							<ul>
*                        D3 : 16-Bit digital value \n
*                        <li> 0 : 32-bit digital/analog value \n
*                        <li> 1 : 16-bit digital value. \n
*				Only a pair number of acquisition channels can be selected.
*							</ul>
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulOption1 :</VAR></b> Reserved
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                            <li>    0:  means the remote function performed OK \n
*                            <li>   -1:  means an system error occured \n
*                            <li>   -2: The nbr of channel in the sequence cannot be null \n
*                            <li>   -3: Channel index selection error \n
*                            <li>   -4: Gain selection error \n
*                            <li>   -5: Polarity selection error \n
*                            <li>   -6: The minimal converting time is 10 us !\n
*                            <li>   -7: Not available conversion time unit \n
*                            <li>   -8: Delay mode selection not available \n
*                            <li>   -9: Delay time unit selection not available \n
*                            <li>  -10: Delay value not available \n
*                            <li>  -11: Trigger mode : 2 different mode cannot be simultaneously be activated \n
*                            <li>  -12: Hardware trigger : edge definition error \n
*                            <li>  -13: Hardware trigger count value not available \n
*                            <li>  -14: Nbr of sequence to acquire by trigger mode not available \n
*                            <li>  -15: Data format not available \n
*                            <li> -100: Channel initialisation kernel function error \n
*                            <li> -101: Conversion time initialisation kernel function error \n
*                            <li> -102: Delay initialisation kernel function error \n
*                            <li> -103: hardware trigger initialisation/enable kernel function error \n
*                            <li> -104: hardware trigger disable kernel function error \n
*                            <li> -105: synchro trigger initialisation/enable kernel function error \n
*                            <li> -106: synchro trigger disable kernel function error \n
*                            <li> -107  Sequence trigger count initialisation error \n
*                            <li> -108: Sequence initialisation kernel function error \n
*                            <li> -109: Start sequence kernel function error \n
* </ul>
*             <b> <VAR>Syserrno :</VAR> </b> system-error code (the value of the libc "errno" code)
* </ul>
* </p>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartSequence(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulNbrOfChannel;
	uint32_t pulChannelList[16];
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulDelayMode;
	uint32_t ulDelayTimeUnit;
	uint32_t ulDelayValue;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartSequence(modbus,ulNbrOfChannel,pulChannelList,pulGainArray,pulPolarityArray,ulConversionTime,ulConversionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulDelayMode,ulDelayTimeUnit,ulDelayValue,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartSequence");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartSequence\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartSequence()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartSequence OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartSequence(struct modbus * modbus,
	uint32_t ulNbrOfChannel,
	uint32_t pulChannelList[16],
	uint32_t pulGainArray[16],
	uint32_t pulPolarityArray[16],
	uint32_t ulConversionTime,
	uint32_t ulConversionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint32_t ulDelayMode,
	uint32_t ulDelayTimeUnit,
	uint32_t ulDelayValue,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/* <p> Initialise and start the analog input sequence acquisition mode </p>
* <p>
* This function is not available for the S7. See function MSXE301x__AnalogInputInitAndStartSequenceTrimed.
* </p>
* <p>
* A sequence is a list of channels (max 16) that are acquired.
* It can be any order of the channels in this list.
* </p>
* <p>
* There are different sequence modes
* <ul>
*    <li> Limited number of sequences / Continuous
*    <li> With/Without delay
* </ul>
* </p>
* <dl>
* <dt> Limited number of sequences</dt>
* <dd>After the acquisition of the defined number of sequences, the acquisition is stopped automatically.</dd>
* <dt>Continuous:</dt>
* <dd>The sequences are acquired continuously until a software-stop-command occurs.</dd>
*
* <dt>Without delay</dt>
* <dd>There is no waiting time between the acquisitions of 2 sequences.</dd>
*
* <dt>With delay</dt>
* <dd>A delay between 2 sequences can be configured: \n
* For this there are 2 delay types:
* <ul>
* <li> Mode 1: The delay time defines the time between 2 sequence beginnings. \n
* <li> Mode 2: The delay time defines the time between the end of a sequence until the beginning of the next sequence.
* </ul>
* </dd>
* </dl>
* <p>
* You can start the acquisition by a hardware or synchro trigger.
* </p>
* The hardware trigger can react to a rising, falling or both edges.\n

* <p>
* You have the following possibility:
* <ul>
*    <li> Define a number of edges before a trigger action is generated \n
* </ul>
* </p>
* <p>
* There are two trigger modes:(for the hardware or synchro trigger)
*<ul>
*    <li> One shot \n
*    <li> Sequence \n
* </ul>
* <p>
* <dl>
* <dt> One shot: </dt>
* <dd>
*    After the software start, the module is waiting for a trigger signal to start the \n
*    acquisition. After this the trigger signal is ignored.\n
* </dd>
*
* <dt> Sequence: </dt>
* <dd>
*    After the software start the module is waiting for the trigger signal and acquires x \n
*    sequences (also adjustable) and then wait again.
* </dd>
* </p>
*/

/** Initialise and start the analog input sequence acquisition mode
*
* <p><b>Parameters:</b></p>
* <ul>
*
*<p>
* @param[in] <b><VAR>ulNbrOfChannel :</VAR></b> nbr of channel in the sequence
*</p>
*<p>
* @param[in] <b><VAR>pulChannelList :</VAR></b> list of the channel who compose the sequence
*</p>
*<p>
* @param[in] <b><VAR>pulGainArray :</VAR></b> Define the gain (1 or 2) to use for each channel.\n
*							<ul>
* 						  <li> 1 : +10 V when Unipolar, +/-10V when Bipolar
* 						  <li> 2 : +5 V when Unipolar,  +/-5V when Bipolar
*                         Each index of the array correspond to the channel :\n
* 						  sample : \n
*                         <li> [0] : Define the gain for the channel 0  \n
* 						  <li> [1] : Define the gain for the channel 1 \n
*                         <li>... \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>pulPolarityArray :</VAR></b> Define the polarity (0:Unipolar or 1:Bipolar) to use for each channel \n
*                         Each index of the array correspond to the channel :\n
* 						  sample : \n
*							<ul>
*                         <li> [0] : Define the polarity for the channel 0 \n
* 						  <li> [1] : Define the polarity for the channel 1 \n
*                         <li>... \n
*							</ul>
*</p>
*
*<p>
* @param[in] <b><VAR>ulConversionTime :</VAR></b> Conversion Time (min 10 us or 40 us)
*</p>
*<p>
* @param[in] <b><VAR>ulConversionTimeUnit :</VAR></b> Conversion Time Unit \n
*							<ul>
*                             <li> 0 : us \n
*                             <li> 1 : ms \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulNbrOfSequence :</VAR></b> Number of sequence to acquire :\n
*							<ul>
*                               <li> 0 : continuous mode \n
*                               <li> <> 0 : number of sequence
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulNbrMaxSequenceToTransfer :</VAR></b> Max nbr of sequence to acquire before a data transfer : (1,65535)
*</p>
*<p>
* @param[in] <b><VAR>ulDelayMode :</VAR></b> Delay Mode : \n
*							<ul>
*                            <li> 0 : delay not used \n
*                            <li> 1 : mode 1 \n
*                            <li> 2 : mode 2
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDelayTimeUnit :</VAR></b> Selection of the time unit \n
*							<ul>
*                               0: us   \n
*                               1: ms   \n
*                               2: s
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDelayValue :</VAR></b> Delay Value : (1..0xFFFF)
*</p>
*<p>
* @param[in] <b><VAR>ulTriggerMask :</VAR></b>	Define the source of the trigger \n
*							<ul>
*                           <li> 0 : trigger disabled \n
* 							<li> 1 : Enable Hardware Digital Input Trigger \n
*                           <li> 2 : Enable Synchro Trigger \n
* 							<li> 3 : Enable both Hardware and Synchro Trigger \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulTriggerMode :</VAR></b>	Define the trigger mode \n
*							<ul>
* 							<li> 1 : One shot trigger \n
*                           <li> 2 : Sequence trigger \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulHardwareTriggerEdge :</VAR></b>	Define the edge of the hardware trigger who generate a trigger action \n
*							<ul>
*                  <li> 1 : rising front (Only if hardware trigger selected) \n
*                  <li> 2 : falling front (Only if hardware trigger selected) \n
*                  <li> 3 : Both front (Only if hardware trigger selected) \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulHardwareTriggerCount :</VAR></b> Define the number of trigger events before the action occur
*							<ul>
*							<li> 0 or 1 : all trigger event start the action \n
*							<li> max value : 65535 \n
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulByTriggerNbrOfSeqToAcquire :</VAR></b> define the number of sequences to acquire by each trigger event
*							<ul>
* 					<li> 0 : continuous mode \n
*                   <li> <> 0 : number of sequence : (1..0xFFFFFFFF)
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulDataFormat :</VAR></b> Data format option \n
*							<ul>
*							<li>
*							<ul>
*                        D0 : Time stamp information \n
*                        <li> 0 : no time stamp information \n
*                        <li> 1 : time stamp information \n
*							</ul>
*							<li>
*							<ul>
*                        D1 : Sequence counter information \n
*                        <li> 0 : No sequence counter information \n
*                        <li> 1 : Sequence counter information \n
*							</ul>
*							<li>
*							<ul>
*                        D2 : Data format \n
*                        <li> 0 : 32/16 bit digital value \n
*                        <li> 1 : 32-bit analog value (in V) \n
*							</ul>
*							<li>
*							<ul>
*                        D3 : 16-Bit digital value \n
*                        <li> 0 : 32-bit digital/analog value \n
*                        <li> 1 : 16-bit digital value. \n
*				Only a pair number of acquisition channels can be selected.
*							</ul>
*							</ul>
*</p>
*<p>
* @param[in] <b><VAR>ulOption1 :</VAR></b> Reserved
* </ul>
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                            <li>    0:  means the remote function performed OK \n
*                            <li>   -1:  means an system error occured \n
*                            <li>   -2: The nbr of channel in the sequence cannot be null \n
*                            <li>   -3: Channel index selection error \n
*                            <li>   -4: Gain selection error \n
*                            <li>   -5: Polarity selection error \n
*                            <li>   -6: The minimal converting time is 10 us !\n
*                            <li>   -7: Not available conversion time unit \n
*                            <li>   -8: Delay mode selection not available \n
*                            <li>   -9: Delay time unit selection not available \n
*                            <li>  -10: Delay value not available \n
*                            <li>  -11: Trigger mode : 2 different mode cannot be simultaneously be activated \n
*                            <li>  -12: Hardware trigger : edge definition error \n
*                            <li>  -13: Hardware trigger count value not available \n
*                            <li>  -14: Nbr of sequence to acquire by trigger mode not available \n
*                            <li>  -15: Data format not available \n
*                            <li> -100: Channel initialisation kernel function error \n
*                            <li> -101: Conversion time initialisation kernel function error \n
*                            <li> -102: Delay initialisation kernel function error \n
*                            <li> -103: hardware trigger initialisation/enable kernel function error \n
*                            <li> -104: hardware trigger disable kernel function error \n
*                            <li> -105: synchro trigger initialisation/enable kernel function error \n
*                            <li> -106: synchro trigger disable kernel function error \n
*                            <li> -107  Sequence trigger count initialisation error \n
*                            <li> -108: Sequence initialisation kernel function error \n
*                            <li> -109: Start sequence kernel function error \n
* </ul>
*             <b> <VAR>Syserrno :</VAR> </b> system-error code (the value of the libc "errno" code)
* </ul>
* </p>
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartSequenceEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulNbrOfChannel;
	uint32_t pulChannelList[16];
	uint32_t pulGainArray[16];
	uint32_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint32_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint32_t ulDelayMode;
	uint32_t ulDelayTimeUnit;
	uint32_t ulDelayValue;
	uint32_t ulTriggerMask;
	uint32_t ulTriggerMode;
	uint32_t ulHardwareTriggerEdge;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartSequenceEx(modbus,ulNbrOfChannel,pulChannelList,pulGainArray,pulPolarityArray,ulConversionTime,ulConversionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulDelayMode,ulDelayTimeUnit,ulDelayValue,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartSequenceEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartSequenceEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartSequenceEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartSequenceEx OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartSequenceEx(struct modbus * modbus,
	uint32_t ulNbrOfChannel,
	uint32_t pulChannelList[16],
	uint32_t pulGainArray[16],
	uint32_t pulPolarityArray[16],
	uint32_t ulConversionTime,
	uint32_t ulConversionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint32_t ulDelayMode,
	uint32_t ulDelayTimeUnit,
	uint32_t ulDelayValue,
	uint32_t ulTriggerMask,
	uint32_t ulTriggerMode,
	uint32_t ulHardwareTriggerEdge,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Stop and release the analog input sequence acquisition mode
*
* @param[in] _ : no input parameter
* @param[out] Response :\n
*             <b> <VAR>iReturnValue :</VAR> </b>
*/
/** <p>Stops the current sequence acquisition.</p>
* <p>
* Must be called before any another call to MSXE301x__AnalogInputInitAndStartSequence.
* </p>
* <p><b>Parameters:</b></p>
* <ul>
* <li>@param[in] <b><VAR>Dummy</VAR></b> : Reserved
* </ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li>    0: means the remote function performed OK \n
*                             <li> -100: Stop sequence kernel function error \n
*                             <li> -101: Release sequence kernel function error \n
*                             <li> -1:  means an system error occured.
* </ul>
* <b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a sequence acquisition was not started
* </ul>
*
*
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputStopAndReleaseSequence(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputStopAndReleaseSequence(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputStopAndReleaseSequence");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputStopAndReleaseSequence\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputStopAndReleaseSequence()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputStopAndReleaseSequence OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputStopAndReleaseSequence(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Stop and release the analog input sequence acquisition mode
*
* @param[in] _ : no input parameter
* @param[out] Response :\n
*             <b> <VAR>iReturnValue :</VAR> </b>
*/
/** <p>Stops the current sequence acquisition.</p>
* <p>
* Must be called before any another call to MSXE301x__AnalogInputInitAndStartSequence.
* </p>
* <p><b>Parameters:</b></p>
* <ul>
* <li>@param[in] <b><VAR>Dummy</VAR></b> : Reserved
* </ul>
*
* <p><b> Returns:</b></p>
* <ul>
* @return <b>Possible return value on the remote system (read them with GetLastCommandStatus)</b>
* <ul>
*                             <li>    0: means the remote function performed OK \n
*                             <li> -100: Stop sequence kernel function error \n
*                             <li> -101: Release sequence kernel function error \n
*                             <li> -1:  means an system error occured.
* </ul>
* <b> <VAR>syserrno :</VAR> </b> system-error code (the value of the libc "errno" code) EPERM means a sequence acquisition was not started
* </ul>
*
*
*/
			
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputStopAndReleaseSequenceEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t Dummy;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputStopAndReleaseSequenceEx(modbus,Dummy,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputStopAndReleaseSequenceEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputStopAndReleaseSequenceEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputStopAndReleaseSequenceEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputStopAndReleaseSequenceEx OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputStopAndReleaseSequenceEx(struct modbus * modbus,
	uint32_t Dummy
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/* <p> Initialise and start the analog input sequence acquisition mode </p>
* <p>
* This function performs the same as MSXE301x__AnalogInputInitAndStartSequence, but has parameters with smaller types that allows it to be compliant with Schneider Electric MODBUS standard.
* </p>
* <p>
* Available from OS revision 5492.
* </p>
*/
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartSequenceTrimed(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint8_t ulNbrOfChannel;
	uint8_t pulChannelList[16];
	uint8_t pulGainArray[16];
	uint8_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint8_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint16_t ulDelayMode;
	uint8_t ulDelayTimeUnit;
	uint16_t ulDelayValue;
	uint8_t ulTriggerMask;
	uint8_t ulTriggerMode;
	uint8_t ulHardwareTriggerEdge;
	uint16_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartSequenceTrimed(modbus,ulNbrOfChannel,pulChannelList,pulGainArray,pulPolarityArray,ulConversionTime,ulConversionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulDelayMode,ulDelayTimeUnit,ulDelayValue,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartSequenceTrimed");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartSequenceTrimed\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartSequenceTrimed()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartSequenceTrimed OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartSequenceTrimed(struct modbus * modbus,
	uint8_t ulNbrOfChannel,
	uint8_t pulChannelList[16],
	uint8_t pulGainArray[16],
	uint8_t pulPolarityArray[16],
	uint32_t ulConversionTime,
	uint8_t ulConversionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint16_t ulDelayMode,
	uint8_t ulDelayTimeUnit,
	uint16_t ulDelayValue,
	uint8_t ulTriggerMask,
	uint8_t ulTriggerMode,
	uint8_t ulHardwareTriggerEdge,
	uint16_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/* <p> Initialise and start the analog input sequence acquisition mode </p>
* <p>
* This function performs the same as MSXE301x__AnalogInputInitAndStartSequence, but has parameters with smaller types that allows it to be compliant with Schneider Electric MODBUS standard.
* </p>
* <p>
* Available from OS revision 5492.
* </p>
*/
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE301x__AnalogInputInitAndStartSequenceTrimedEx(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint8_t ulNbrOfChannel;
	uint8_t pulChannelList[16];
	uint8_t pulGainArray[16];
	uint8_t pulPolarityArray[16];
	uint32_t ulConversionTime;
	uint8_t ulConversionTimeUnit;
	uint32_t ulNbrOfSequence;
	uint32_t ulNbrMaxSequenceToTransfer;
	uint16_t ulDelayMode;
	uint8_t ulDelayTimeUnit;
	uint16_t ulDelayValue;
	uint8_t ulTriggerMask;
	uint8_t ulTriggerMode;
	uint8_t ulHardwareTriggerEdge;
	uint16_t ulHardwareTriggerCount;
	uint32_t ulByTriggerNbrOfSeqToAcquire;
	uint32_t ulDataFormat;
	uint32_t ulOption1;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE301x__AnalogInputInitAndStartSequenceTrimedEx(modbus,ulNbrOfChannel,pulChannelList,pulGainArray,pulPolarityArray,ulConversionTime,ulConversionTimeUnit,ulNbrOfSequence,ulNbrMaxSequenceToTransfer,ulDelayMode,ulDelayTimeUnit,ulDelayValue,ulTriggerMask,ulTriggerMode,ulHardwareTriggerEdge,ulHardwareTriggerCount,ulByTriggerNbrOfSeqToAcquire,ulDataFormat,ulOption1,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE301x__AnalogInputInitAndStartSequenceTrimedEx");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE301x__AnalogInputInitAndStartSequenceTrimedEx\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE301x__AnalogInputInitAndStartSequenceTrimedEx()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE301x__AnalogInputInitAndStartSequenceTrimedEx OK\n");
	return 0;
}

*/

int modbus_call_MSXE301x__AnalogInputInitAndStartSequenceTrimedEx(struct modbus * modbus,
	uint8_t ulNbrOfChannel,
	uint8_t pulChannelList[16],
	uint8_t pulGainArray[16],
	uint8_t pulPolarityArray[16],
	uint32_t ulConversionTime,
	uint8_t ulConversionTimeUnit,
	uint32_t ulNbrOfSequence,
	uint32_t ulNbrMaxSequenceToTransfer,
	uint16_t ulDelayMode,
	uint8_t ulDelayTimeUnit,
	uint16_t ulDelayValue,
	uint8_t ulTriggerMask,
	uint8_t ulTriggerMode,
	uint8_t ulHardwareTriggerEdge,
	uint16_t ulHardwareTriggerCount,
	uint32_t ulByTriggerNbrOfSeqToAcquire,
	uint32_t ulDataFormat,
	uint32_t ulOption1
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE301X_CLIENT_DEFINITION_H_


