using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace StartSequence
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Useful variable
        /// </summary>
        private ComboBox[] channels;

        public Form1()
        {
            InitializeComponent();

            // Init useful array
            this.channels = new ComboBox[16];
            this.channels[0] = channel1Box;
            this.channels[1] = channel2Box;
            this.channels[2] = channel3Box;
            this.channels[3] = channel4Box;
            this.channels[4] = channel5Box;
            this.channels[5] = channel6Box;
            this.channels[6] = channel7Box;
            this.channels[7] = channel8Box;
            this.channels[8] = channel9Box;
            this.channels[9] = channel10Box;
            this.channels[10] = channel11Box;
            this.channels[11] = channel12Box;
            this.channels[12] = channel13Box;
            this.channels[13] = channel14Box;
            this.channels[14] = channel15Box;
            this.channels[15] = channel16Box;
        }

        /// <summary>
        /// The user change the size of the sequence
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void sequenceSizeBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Enable possible channels
            for (int i = 0; i < this.sequenceSizeBox.SelectedIndex + 1; i++)
            {
                this.channels[i].Enabled = true;
            }

            // Unable un possible channels
            for (int i = (this.sequenceSizeBox.SelectedIndex + 1); i < 16; i++)
            {
                this.channels[i].Enabled = false;
            }
        }

        /// <summary>
        /// Set the last parameters used by the user
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            this.systemTypeBox.SelectedIndex = Properties.Settings.Default.systemType;
            this.sequenceSizeBox.SelectedIndex = Properties.Settings.Default.sequenceSize;
            this.channel1Box.SelectedIndex = Properties.Settings.Default.channel0;
            this.channel2Box.SelectedIndex = Properties.Settings.Default.channel1;
            this.channel3Box.SelectedIndex = Properties.Settings.Default.channel2;
            this.channel4Box.SelectedIndex = Properties.Settings.Default.channel3;
            this.channel5Box.SelectedIndex = Properties.Settings.Default.channel4;
            this.channel6Box.SelectedIndex = Properties.Settings.Default.channel5;
            this.channel7Box.SelectedIndex = Properties.Settings.Default.channel6;
            this.channel8Box.SelectedIndex = Properties.Settings.Default.channel7;
            this.channel9Box.SelectedIndex = Properties.Settings.Default.channel8;
            this.channel10Box.SelectedIndex = Properties.Settings.Default.channel9;
            this.channel11Box.SelectedIndex = Properties.Settings.Default.channel10;
            this.channel12Box.SelectedIndex = Properties.Settings.Default.channel11;
            this.channel13Box.SelectedIndex = Properties.Settings.Default.channel12;
            this.channel14Box.SelectedIndex = Properties.Settings.Default.channel13;
            this.channel15Box.SelectedIndex = Properties.Settings.Default.channel14;
            this.channel16Box.SelectedIndex = Properties.Settings.Default.channel15;
            this.conversionTimeBox.Text = Properties.Settings.Default.conversionTime.ToString();
            this.conversionTimeUnitBox.SelectedIndex = Properties.Settings.Default.conversionTimeUnit;
            this.sequenceToAcquireBox.Text = Properties.Settings.Default.sequenceToAcquire.ToString();
            this.sequenceBeforeSendingBox.Text = Properties.Settings.Default.sequenceBeforeSending.ToString();
            this.counterBox.Checked = Properties.Settings.Default.counter;
            this.timestampBox.Checked = Properties.Settings.Default.timestamp;
            this.formatBox.Checked = Properties.Settings.Default.analog;
            this.ipBox1.Text = Properties.Settings.Default.ip1;
            this.ipBox2.Text = Properties.Settings.Default.ip2;
            this.ipBox3.Text = Properties.Settings.Default.ip3;
            this.ipBox4.Text = Properties.Settings.Default.ip4;

            // Unselect un possible channels
            for (int i = (this.sequenceSizeBox.SelectedIndex+1); i < 16; i++)
            {
                this.channels[i].Enabled = false;
            }
        }

        /// <summary>
        /// Form is closing
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.systemType = this.systemTypeBox.SelectedIndex;
            Properties.Settings.Default.sequenceSize = this.sequenceSizeBox.SelectedIndex;
            Properties.Settings.Default.channel0 = this.channel1Box.SelectedIndex;
            Properties.Settings.Default.channel1 = this.channel2Box.SelectedIndex;
            Properties.Settings.Default.channel2 = this.channel3Box.SelectedIndex;
            Properties.Settings.Default.channel3 = this.channel4Box.SelectedIndex;
            Properties.Settings.Default.channel4 = this.channel5Box.SelectedIndex;
            Properties.Settings.Default.channel5 = this.channel6Box.SelectedIndex;
            Properties.Settings.Default.channel6 = this.channel7Box.SelectedIndex;
            Properties.Settings.Default.channel7 = this.channel8Box.SelectedIndex;
            Properties.Settings.Default.channel8 = this.channel9Box.SelectedIndex;
            Properties.Settings.Default.channel9 = this.channel10Box.SelectedIndex;
            Properties.Settings.Default.channel10 = this.channel11Box.SelectedIndex;
            Properties.Settings.Default.channel11 = this.channel12Box.SelectedIndex;
            Properties.Settings.Default.channel12 = this.channel13Box.SelectedIndex;
            Properties.Settings.Default.channel13 = this.channel14Box.SelectedIndex;
            Properties.Settings.Default.channel14 = this.channel15Box.SelectedIndex;
            Properties.Settings.Default.channel15 = this.channel16Box.SelectedIndex;
            try
            {
                Properties.Settings.Default.conversionTime = Convert.ToInt32(this.conversionTimeBox.Text);
            }
            catch (Exception)
            {
                Properties.Settings.Default.conversionTime = 10;
            }
            Properties.Settings.Default.conversionTimeUnit = this.conversionTimeUnitBox.SelectedIndex;
            try
            {
                Properties.Settings.Default.sequenceToAcquire = Convert.ToInt32(this.sequenceToAcquireBox.Text);
            }
            catch (Exception)
            {
                Properties.Settings.Default.sequenceToAcquire = 0;
            }
            try
            {
                Properties.Settings.Default.sequenceBeforeSending = Convert.ToInt32(this.sequenceBeforeSendingBox.Text);
            }
            catch (Exception)
            {
                Properties.Settings.Default.sequenceBeforeSending = 1;
            }
            Properties.Settings.Default.counter = this.counterBox.Checked;
            Properties.Settings.Default.timestamp = this.timestampBox.Checked;
            Properties.Settings.Default.analog = this.formatBox.Checked;
            Properties.Settings.Default.ip1 = this.ipBox1.Text;
            Properties.Settings.Default.ip2 = this.ipBox2.Text;
            Properties.Settings.Default.ip3 = this.ipBox3.Text;
            Properties.Settings.Default.ip4 = this.ipBox4.Text;
            Properties.Settings.Default.Save();
        }

        /// <summary>
        /// Click on start
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void startButton_Click(object sender, EventArgs e)
        {
            if (this.systemTypeBox.SelectedIndex == 0)
            {
                this.StartSequence3011();
            }
            else if (this.systemTypeBox.SelectedIndex == 1)
            {
                this.StartSequence3021();
            }
        }

        private void StartSequence3011()
        {
            MSXE301x.MSXE301x webReference = new MSXE301x.MSXE301x();

            webReference.Url = "http://" + ipBox1.Text + "." + ipBox2.Text + "." + ipBox3.Text + "." + ipBox4.Text + ":5555";
            webReference.Timeout = 2000;

            ulong channelNb = (ulong)(sequenceSizeBox.SelectedIndex + 1);
            MSXE301x.unsignedLong16FixedArrayParam channelList = new StartSequence.MSXE301x.unsignedLong16FixedArrayParam();
            MSXE301x.unsignedLong16FixedArrayParam gain = new StartSequence.MSXE301x.unsignedLong16FixedArrayParam();
            MSXE301x.unsignedLong16FixedArrayParam polarity = new StartSequence.MSXE301x.unsignedLong16FixedArrayParam();
            channelList.ulValue = new ulong[16];
            gain.ulValue = new ulong[16];
            polarity.ulValue = new ulong[16];
            ulong conversionTime = (ulong)Convert.ToInt32(conversionTimeBox.Text);
            ulong sequenceNbr = (ulong)Convert.ToInt32(sequenceToAcquireBox.Text);
            ulong sequenceBefore = (ulong)Convert.ToInt32(sequenceBeforeSendingBox.Text);
            ulong dataFormat = 0;
            int syserrno = 0;

            for (int i = 0; i < sequenceSizeBox.SelectedIndex + 1; i++)
            {
                channelList.ulValue[i] = (ulong)channels[i].SelectedIndex;
            }
            for (int i = 0; i < 16; i++)
            {
                gain.ulValue[i] = 1;
                polarity.ulValue[i] = 0;
            }

            if (timestampBox.Checked == true)
            {
                dataFormat += 1;
            }
            if (counterBox.Checked == true)
            {
                dataFormat += 2;
            }
            if (formatBox.Checked == true)
            {
                dataFormat += 4;
            }

            try
            {
                int error = 0;
                if ((error = webReference.AnalogInputInitAndStartSequence(channelNb,
                    channelList,
                    gain,
                    polarity,
                    conversionTime,
                    (ulong)conversionTimeUnitBox.SelectedIndex,
                    sequenceNbr,
                    sequenceBefore,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    dataFormat,
                    0,
                    0,
                    0,
                    out syserrno)) != 0)
                {
                    infoBox.Text = "AnalogInputInitAndStartSequence error : " + error.ToString() + " syserrno : " + syserrno.ToString();
                }
                else
                {
                    infoBox.Text = "AnalogInputInitAndStartSequence success";
                }
            }
            catch (Exception ex)
            {
                infoBox.Text = "AnalogInputInitAndStartSequence error : " + ex.Message;
            }
        }

        private void StartSequence3021()
        {
            MSXE302x.MSXE302x webReference = new MSXE302x.MSXE302x();

            webReference.Url = "http://" + ipBox1.Text + "." + ipBox2.Text + "." + ipBox3.Text + "." + ipBox4.Text + ":5555";
            webReference.Timeout = 2000;

            ulong channelNb = (ulong)(sequenceSizeBox.SelectedIndex + 1);
            MSXE302x.unsignedLong16FixedArrayParam channelList = new StartSequence.MSXE302x.unsignedLong16FixedArrayParam();
            MSXE302x.unsignedLong16FixedArrayParam gain = new StartSequence.MSXE302x.unsignedLong16FixedArrayParam();
            MSXE302x.unsignedLong16FixedArrayParam polarity = new StartSequence.MSXE302x.unsignedLong16FixedArrayParam();
            channelList.ulValue = new ulong[16];
            gain.ulValue = new ulong[16];
            polarity.ulValue = new ulong[16];
            ulong conversionTime = (ulong)Convert.ToInt32(conversionTimeBox.Text);
            ulong sequenceNbr = (ulong)Convert.ToInt32(sequenceToAcquireBox.Text);
            ulong sequenceBefore = (ulong)Convert.ToInt32(sequenceBeforeSendingBox.Text);
            ulong dataFormat = 0;
            int syserrno = 0;

            for (int i = 0; i < sequenceSizeBox.SelectedIndex + 1; i++)
            {
                channelList.ulValue[i] = (ulong)channels[i].SelectedIndex;
            }
            for (int i = 0; i < 16; i++)
            {
                gain.ulValue[i] = 1;
                polarity.ulValue[i] = 0;
            }

            if (timestampBox.Checked == true)
            {
                dataFormat += 1;
            }
            if (counterBox.Checked == true)
            {
                dataFormat += 2;
            }
            if (formatBox.Checked == true)
            {
                dataFormat += 4;
            }

            try
            {
                int error = 0;
                if ((error = webReference.AnalogInputInitAndStartSequence(channelNb,
                    channelList,
                    gain,
                    polarity,
                    conversionTime,
                    (ulong)conversionTimeUnitBox.SelectedIndex,
                    sequenceNbr,
                    sequenceBefore,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    0,
                    dataFormat,
                    0,
                    0,
                    0,
                    out syserrno)) != 0)
                {
                    infoBox.Text = "AnalogInputInitAndStartSequence error : " + error.ToString() + " syserrno : " + syserrno.ToString();
                }
                else
                {
                    infoBox.Text = "AnalogInputInitAndStartSequence success";
                }
            }
            catch (Exception ex)
            {
                infoBox.Text = "AnalogInputInitAndStartSequence error : " + ex.Message;
            }
        }

        /// <summary>
        /// Click on stop
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void stopButton_Click(object sender, EventArgs e)
        {
            if (this.systemTypeBox.SelectedIndex == 0)
            {
                this.StopSequence3011();
            }
            else if (this.systemTypeBox.SelectedIndex == 1)
            {
                this.StopSequence3021();
            }
        }

        private void StopSequence3011()
        {
            int syserrno = 0;
            MSXE301x.MSXE301x webReference = new MSXE301x.MSXE301x();
            webReference.Url = "http://" + ipBox1.Text + "." + ipBox2.Text + "." + ipBox3.Text + "." + ipBox4.Text + ":5555";
            webReference.Timeout = 2000;

            try
            {
                if (webReference.AnalogInputStopAndReleaseSequence(out syserrno) != 0)
                {
                    infoBox.Text = "AnalogInputStopAndReleaseSequence error : " + syserrno.ToString();
                }
                else
                {
                    infoBox.Text = "AnalogInputStopAndReleaseSequence success";
                }
            }
            catch (Exception ex)
            {
                infoBox.Text = "AnalogInputStopAndReleaseSequence error : " + ex.Message;
            }
        }

        private void StopSequence3021()
        {
            int syserrno = 0;
            MSXE302x.MSXE302x webReference = new MSXE302x.MSXE302x();
            webReference.Url = "http://" + ipBox1.Text + "." + ipBox2.Text + "." + ipBox3.Text + "." + ipBox4.Text + ":5555";
            webReference.Timeout = 2000;

            try
            {
                if (webReference.AnalogInputStopAndReleaseSequence(out syserrno) != 0)
                {
                    infoBox.Text = "AnalogInputStopAndReleaseSequence error : " + syserrno.ToString();
                }
                else
                {
                    infoBox.Text = "AnalogInputStopAndReleaseSequence success";
                }
            }
            catch (Exception ex)
            {
                infoBox.Text = "AnalogInputStopAndReleaseSequence error : " + ex.Message;
            }
        }
    }
}