/** @file MSXE301x.h
 * 
 * Header file for MSXE301x library.
 *    
 *  @par CREATION  
 *  @author Guinot Catherine
 *  @date   14.01.2008
 *  
 *  @par VERSION
 *  @verbatim
 *  $LastChangedRevision:$
 *  $LastChangedDate:$
 *  @endverbatim     
 */ 

#ifndef MSXE301x_H_
#define MSXE301x_H_

#define __COMPILER__
#include "define.h"

//----------------------------------------------------------------------------------------------------------------------
// DRIVER
//----------------------------------------------------------------------------------------------------------------------

_INT_ i_MSXE301x_OpenDriver (struct soap **SoapEnv);
_INT_ i_MSXE301x_CloseDriver (struct soap *SoapEnv);


//----------------------------------------------------------------------------------------------------------------------
// GENERAL
//----------------------------------------------------------------------------------------------------------------------

_INT_ i_MXCommon_GetModuleType (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno, PCHAR pc_ModuleType);


_INT_ i_MSXE301x_AnalogInputGetChannelType (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno, PDWORD pdw_ChannelType);

//----------------------------------------------------------------------------------------------------------------------
// AUTO-REFRESH
//----------------------------------------------------------------------------------------------------------------------

_INT_ i_MSXE301x_AnalogInputInitAndStartAutoRefresh (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno,
												     DWORD dw_ChannelMask,
		                                             PDWORD pdw_GainArray,
		                                             PDWORD pdw_PolarityArray,
		                                             DWORD dw_AverageMode,
		                                             DWORD dw_AverageValue,
		                                             DWORD dw_ConversionTime,
		                                             DWORD dw_ConversionTimeUnit,
		                                             DWORD dw_TriggerMask, 
		                                             DWORD dw_TriggerMode,
		                                             DWORD dw_HardwareTriggerEdge,
		                                             DWORD dw_HardwareTriggerCount,
		                                             DWORD dw_ByTriggerNbrOfSeqToAcquire,
		                                             DWORD dw_DataFormat,
		                                             DWORD dw_Option1,
		                                             DWORD dw_Option2,
		                                             DWORD dw_Option3);

_INT_ i_MSXE301x_AnalogInputGetAutoRefreshValues (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError,PINT pi_Syserrno,
                                                  PDWORD pdw_TimeStampLow,
												  PDWORD pdw_TimeStampHigh,
												  PDWORD pdw_CounterValue,
												  PDWORD pdw_AutoRefreshValues);

_INT_ i_MSXE301x_AnalogInputStopAndReleaseAutoRefresh (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno);


//----------------------------------------------------------------------------------------------------------------------
// SEQUENCE
//----------------------------------------------------------------------------------------------------------------------

_INT_ i_MSXE301x_AnalogInputInitAndStartSequence (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno,
												  DWORD dw_NbrOfChannel,
		                                          PDWORD pdw_ChannelList,
		                                          PDWORD pdw_GainArray,
		                                          PDWORD pdw_PolarityArray,
		                                          DWORD dw_ConversionTime,
		                                          DWORD dw_ConversionTimeUnit,
		                                          DWORD dw_NbrOfSequence,
		                                          DWORD dw_NbrMaxSequenceToTransfer,
		                                          DWORD dw_DelayMode,
		                                          DWORD dw_DelayTimeUnit,
		                                          DWORD dw_DelayValue, 
		                                          DWORD dw_TriggerMask,
		                                          DWORD dw_TriggerMode,
		                                          DWORD dw_HardwareTriggerEdge,
		                                          DWORD dw_HardwareTriggerCount,
		                                          DWORD dw_ByTriggerNbrOfSeqToAcquire, 
		                                          DWORD dw_DataFormat,
		                                          DWORD dw_Option1,
		                                          DWORD dw_Option2,
		                                          DWORD dw_Option3);

_INT_ i_MSXE301x_AnalogInputStopAndReleaseSequence (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError,PINT pi_Syserrno);

//----------------------------------------------------------------------------------------------------------------------
// CALIBRATION
//----------------------------------------------------------------------------------------------------------------------

_INT_ i_MSXE301x_CalibrationStart (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno,
				  			       DWORD dw_CalibrationMode,
								   DWORD dw_Gain,
								   DOUBLE d_CalibrationValue);

_INT_ i_MSXE301x_CalibrationGetCurrentStatus (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError, PINT pi_Syserrno,
										  	  PDWORD pdw_Status, 
											  PDOUBLE pd_CurrentValue,
											  PDWORD pdw_Error);

_INT_ i_MSXE301x_CalibrationNextStep (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError,PINT pi_Syserrno);


_INT_ i_MSXE301x_CalibrationBreak  (struct soap *SoapEnv, PCHAR pc_IPAddress, PINT pi_SOAPError,PINT pi_Syserrno);






#endif // #ifndef MSXE301x_H_
