#include <utility.h>
#include <stdio.h>

/**
*  useful for lab windows cvi
*  since we only use pointer to this structure
**/
struct soap
{
  int dummy;
};

#include <MSXE301x.h>

/**
* Entry point
**/
int main()
{
	struct soap * env;
	INT returnvalue = 0;
	INT soaperror = 0;
	INT syserrno = 0;
	char ipaddress[32] = {0};
	DWORD channellist[4] = {0,4,8,12};
	DWORD gainarray[16] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}; // +/-10V
	DWORD polarityarray[16] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}; // Bipolar
	
	printf("Please enter the ip address of your system :\n");
	scanf("%s", ipaddress);

	/**
	*  Initialize resources
	**/
	if ( ( returnvalue = i_MSXE301x_OpenDriver(&env) ) != 0 )
	{
		printf("i_MSXE301x_OpenDriver error : %d\n", returnvalue);
		GetKey();
		return -1;
	}
	printf("i_MSXE301x_OpenDriver: ok\n");
	
	/**
	*  Start a sequence acquisition
	**/
	if ( ( returnvalue = i_MSXE301x_AnalogInputInitAndStartSequence( env, ipaddress, &soaperror, &syserrno,
		4, 		// 4 channels
		channellist,
		gainarray,
		polarityarray,
		100, 	// 100
		1,		// ms
		0,		// continuous
		1,		// wait 1 sequence before sending
		0,		// delay disabled
		0,
		0,
		0,		// trigger disabled
		0,
		0,
		0,
		0,
		0,		// data format
		0,
		0,
		0) ) != 0 )
	{
		printf("i_MSXE301x_AnalogInputInitAndStartSequence error : %d\n", returnvalue);
		i_MSXE301x_CloseDriver(env);
		GetKey();
		return -1;
	}
	
	/**
	*  Check for error
	**/
	if ( (soaperror != 0) || (syserrno != 0) )
	{
		printf("i_MSXE301x_AnalogInputInitAndStartSequence. syserrno : %d, soaperror : %d\n", syserrno, soaperror);
		i_MSXE301x_CloseDriver(env);
		GetKey();
		return -1;
	}
	
	printf("i_MSXE301x_AnalogInputInitAndStartSequence: ok\n");
		
	/**
	*  Stop the sequence acquisition
	**/
	if ( ( returnvalue = i_MSXE301x_AnalogInputStopAndReleaseSequence( env, ipaddress, &soaperror, &syserrno)) != 0 )
	{
		printf("i_MSXE301x_AnalogInputStopAndReleaseSequence error : %d\n", returnvalue);
		i_MSXE301x_CloseDriver(env);
		GetKey();
		return -1;
	}
	
	/**
	*  Check for error
	**/
	if ( (soaperror != 0) || (syserrno != 0) )
	{
		printf("i_MSXE301x_AnalogInputStopAndReleaseSequence. syserrno : %d, soaperror : %d\n", syserrno, soaperror);
		i_MSXE301x_CloseDriver(env);
		GetKey();
		return -1;
	}
	
	printf("i_MSXE301x_AnalogInputStopAndReleaseSequence: ok\n");
	
	/**
	*  Release resources
	**/
	if ( ( returnvalue = i_MSXE301x_CloseDriver(env) ) != 0 )
	{
		printf("i_MSXE301x_CloseDriver error : %d\n", returnvalue);
		GetKey();
		return -1;
	}
	printf("i_MSXE301x_CloseDriver: ok\n");

	// Wait user input
	GetKey();
	return 0;
}
